//importing select, json, geoPath, geoEquirectangular functions from d3
import { select, json, geoPath, geoEquirectangular } from 'd3';
//importing feature method from TopoJSON that creates the GeoJSON objects
import { feature } from 'topojson';

//  select() - selects only the DOM element defined in the given CSS selector
const svg = select('svg');

// geoEquirectangular() - for geo-projection of the world map 
const projection = geoEquirectangular();
const pathGenerator = geoPath().projection(projection);

// adds a path element to the existing SVG
//'sphere' defines the class 
svg.append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}));

//.json file which contains the world map data required to visualize.
json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
  .then(data => {
    const countries = feature(data, data.objects.countries);
  
// selectAll() - selects all the element that matches the specified selector string
    svg.selectAll('path').data(countries.features)
  
//enter() - creates the initial join of data to elements
      .enter().append('path')
        .attr('class', 'country')
        .attr('d', pathGenerator);
  });